#include "qwayland-greenisland-outputmanagement.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    greenisland_outputmanagement::greenisland_outputmanagement(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_outputmanagement::greenisland_outputmanagement(struct ::greenisland_outputmanagement *obj)
        : m_greenisland_outputmanagement(obj)
    {
    }

    greenisland_outputmanagement::greenisland_outputmanagement()
        : m_greenisland_outputmanagement(0)
    {
    }

    greenisland_outputmanagement::~greenisland_outputmanagement()
    {
    }

    void greenisland_outputmanagement::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_outputmanagement = static_cast<struct ::greenisland_outputmanagement *>(wl_registry_bind(registry, id, &greenisland_outputmanagement_interface, version));
    }

    void greenisland_outputmanagement::init(struct ::greenisland_outputmanagement *obj)
    {
        m_greenisland_outputmanagement = obj;
    }

    bool greenisland_outputmanagement::isInitialized() const
    {
        return m_greenisland_outputmanagement != 0;
    }

    const struct wl_interface *greenisland_outputmanagement::interface()
    {
        return &::greenisland_outputmanagement_interface;
    }

    struct ::greenisland_outputconfiguration *greenisland_outputmanagement::create_configuration()
    {
        return greenisland_outputmanagement_create_configuration(
            m_greenisland_outputmanagement);
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration(struct ::greenisland_outputconfiguration *obj)
        : m_greenisland_outputconfiguration(obj)
    {
        init_listener();
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration()
        : m_greenisland_outputconfiguration(0)
    {
    }

    greenisland_outputconfiguration::~greenisland_outputconfiguration()
    {
    }

    void greenisland_outputconfiguration::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_outputconfiguration = static_cast<struct ::greenisland_outputconfiguration *>(wl_registry_bind(registry, id, &greenisland_outputconfiguration_interface, version));
        init_listener();
    }

    void greenisland_outputconfiguration::init(struct ::greenisland_outputconfiguration *obj)
    {
        m_greenisland_outputconfiguration = obj;
        init_listener();
    }

    bool greenisland_outputconfiguration::isInitialized() const
    {
        return m_greenisland_outputconfiguration != 0;
    }

    const struct wl_interface *greenisland_outputconfiguration::interface()
    {
        return &::greenisland_outputconfiguration_interface;
    }

    void greenisland_outputconfiguration::enable(struct ::wl_output *output, int32_t enable)
    {
        greenisland_outputconfiguration_enable(
            m_greenisland_outputconfiguration,
            output,
            enable);
    }

    void greenisland_outputconfiguration::primary(struct ::wl_output *output, int32_t primary)
    {
        greenisland_outputconfiguration_primary(
            m_greenisland_outputconfiguration,
            output,
            primary);
    }

    void greenisland_outputconfiguration::mode(struct ::wl_output *output, int32_t mode_id)
    {
        greenisland_outputconfiguration_mode(
            m_greenisland_outputconfiguration,
            output,
            mode_id);
    }

    void greenisland_outputconfiguration::transform(struct ::wl_output *output, int32_t transform)
    {
        greenisland_outputconfiguration_transform(
            m_greenisland_outputconfiguration,
            output,
            transform);
    }

    void greenisland_outputconfiguration::position(struct ::wl_output *output, int32_t x, int32_t y)
    {
        greenisland_outputconfiguration_position(
            m_greenisland_outputconfiguration,
            output,
            x,
            y);
    }

    void greenisland_outputconfiguration::scale(struct ::wl_output *output, int32_t scale)
    {
        greenisland_outputconfiguration_scale(
            m_greenisland_outputconfiguration,
            output,
            scale);
    }

    void greenisland_outputconfiguration::apply()
    {
        greenisland_outputconfiguration_apply(
            m_greenisland_outputconfiguration);
    }

    void greenisland_outputconfiguration::outputconfiguration_applied()
    {
    }

    void greenisland_outputconfiguration::handle_applied(
        void *data,
        struct ::greenisland_outputconfiguration *object)
    {
        Q_UNUSED(object);
        static_cast<greenisland_outputconfiguration *>(data)->outputconfiguration_applied();
    }

    void greenisland_outputconfiguration::outputconfiguration_failed()
    {
    }

    void greenisland_outputconfiguration::handle_failed(
        void *data,
        struct ::greenisland_outputconfiguration *object)
    {
        Q_UNUSED(object);
        static_cast<greenisland_outputconfiguration *>(data)->outputconfiguration_failed();
    }

    const struct greenisland_outputconfiguration_listener greenisland_outputconfiguration::m_greenisland_outputconfiguration_listener = {
        greenisland_outputconfiguration::handle_applied,
        greenisland_outputconfiguration::handle_failed
    };

    void greenisland_outputconfiguration::init_listener()
    {
        greenisland_outputconfiguration_add_listener(m_greenisland_outputconfiguration, &m_greenisland_outputconfiguration_listener, this);
    }
}

QT_END_NAMESPACE
