/* Generated by wayland-scanner 1.12.0 */

#ifndef GREENISLAND_SCREENCASTER_SERVER_PROTOCOL_H
#define GREENISLAND_SCREENCASTER_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_greenisland_screencaster The greenisland_screencaster protocol
 * @section page_ifaces_greenisland_screencaster Interfaces
 * - @subpage page_iface_greenisland_screencaster - capture frames of an output
 * - @subpage page_iface_greenisland_screencast - frame capture
 * @section page_copyright_greenisland_screencaster Copyright
 * <pre>
 *
 * Copyright (C) 2015-2016 Pier Luigi Fiorini
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * </pre>
 */
struct greenisland_screencast;
struct greenisland_screencaster;
struct wl_buffer;
struct wl_output;

/**
 * @page page_iface_greenisland_screencaster greenisland_screencaster
 * @section page_iface_greenisland_screencaster_desc Description
 *
 * This interface is used by programs to record screencasts of an output.
 *
 * The client asks the compositor to capture an output, as a result a
 * greenisland_screencast object is created to drive the screencast.
 *
 * See the documentation of greenisland_screencast for more details.
 * @section page_iface_greenisland_screencaster_api API
 * See @ref iface_greenisland_screencaster.
 */
/**
 * @defgroup iface_greenisland_screencaster The greenisland_screencaster interface
 *
 * This interface is used by programs to record screencasts of an output.
 *
 * The client asks the compositor to capture an output, as a result a
 * greenisland_screencast object is created to drive the screencast.
 *
 * See the documentation of greenisland_screencast for more details.
 */
extern const struct wl_interface greenisland_screencaster_interface;
/**
 * @page page_iface_greenisland_screencast greenisland_screencast
 * @section page_iface_greenisland_screencast_desc Description
 *
 * This interface drives the frame capture into client-allocated buffers.
 * Immediately after this object is created, the compositor sends
 * the 'setup' event with the buffer size. The client uses this information
 * to allocate a buffer to hold the frame image.
 *
 * When the buffer is created, the 'record' request must be invoked each
 * time the client wants to record a frame.
 * @section page_iface_greenisland_screencast_api API
 * See @ref iface_greenisland_screencast.
 */
/**
 * @defgroup iface_greenisland_screencast The greenisland_screencast interface
 *
 * This interface drives the frame capture into client-allocated buffers.
 * Immediately after this object is created, the compositor sends
 * the 'setup' event with the buffer size. The client uses this information
 * to allocate a buffer to hold the frame image.
 *
 * When the buffer is created, the 'record' request must be invoked each
 * time the client wants to record a frame.
 */
extern const struct wl_interface greenisland_screencast_interface;

#ifndef GREENISLAND_SCREENCASTER_ERROR_ENUM
#define GREENISLAND_SCREENCASTER_ERROR_ENUM
/**
 * @ingroup iface_greenisland_screencaster
 * greenisland_screencaster error values
 *
 * These errors can be emitted in response to
 * greenisland_screencaster requests.
 */
enum greenisland_screencaster_error {
	/**
	 * The client passed an invalid output
	 */
	GREENISLAND_SCREENCASTER_ERROR_BAD_OUTPUT = 0,
};
#endif /* GREENISLAND_SCREENCASTER_ERROR_ENUM */

/**
 * @ingroup iface_greenisland_screencaster
 * @struct greenisland_screencaster_interface
 */
struct greenisland_screencaster_interface {
	/**
	 * initiate a screencast
	 *
	 * This creates a greenisland_screencast object to drive
	 * screencasts. See the documentation of greenisland_screencast for
	 * more details.
	 *
	 * If the output is not valid, a protocol error will be sent.
	 */
	void (*capture)(struct wl_client *client,
			struct wl_resource *resource,
			uint32_t id,
			struct wl_resource *output);
};


/**
 * @ingroup iface_greenisland_screencaster
 */
#define GREENISLAND_SCREENCASTER_CAPTURE_SINCE_VERSION 1

#ifndef GREENISLAND_SCREENCAST_ERROR_ENUM
#define GREENISLAND_SCREENCAST_ERROR_ENUM
/**
 * @ingroup iface_greenisland_screencast
 * greenisland_screencast error values
 *
 * These errors are emitted with the 'failed' event when a
 * capture request fails.
 */
enum greenisland_screencast_error {
	/**
	 * Buffer doesn't match requirements
	 */
	GREENISLAND_SCREENCAST_ERROR_BAD_BUFFER = 0,
};
#endif /* GREENISLAND_SCREENCAST_ERROR_ENUM */

#ifndef GREENISLAND_SCREENCAST_TRANSFORM_ENUM
#define GREENISLAND_SCREENCAST_TRANSFORM_ENUM
/**
 * @ingroup iface_greenisland_screencast
 * frame buffer transform
 *
 * These values are emitted with the 'frame' event and represent
 * the transform that is applied to the frame buffer.
 */
enum greenisland_screencast_transform {
	/**
	 * No particular transform has been applied
	 */
	GREENISLAND_SCREENCAST_TRANSFORM_NORMAL = 1,
	/**
	 * Y axis is inverted
	 */
	GREENISLAND_SCREENCAST_TRANSFORM_Y_INVERTED = 2,
};
#endif /* GREENISLAND_SCREENCAST_TRANSFORM_ENUM */

/**
 * @ingroup iface_greenisland_screencast
 * @struct greenisland_screencast_interface
 */
struct greenisland_screencast_interface {
	/**
	 * destroy greenisland_screencast
	 *
	 * Destroy this greenisland_screencast object. Pending capture
	 * requests will be discarded.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * request a frame to be recorded
	 *
	 * Ask the compositor to record its next frame, saving contents
	 * into the specified buffer. The 'frame' event will be sent after
	 * the frame is recorder. Only one frame will be recorder at a
	 * time, call this request again in order to record another frame.
	 * @param buffer client buffer that will hold the data
	 */
	void (*record)(struct wl_client *client,
		       struct wl_resource *resource,
		       struct wl_resource *buffer);
};

#define GREENISLAND_SCREENCAST_SETUP 0
#define GREENISLAND_SCREENCAST_FRAME 1
#define GREENISLAND_SCREENCAST_FAILED 2
#define GREENISLAND_SCREENCAST_CANCELLED 3

/**
 * @ingroup iface_greenisland_screencast
 */
#define GREENISLAND_SCREENCAST_SETUP_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_screencast
 */
#define GREENISLAND_SCREENCAST_FRAME_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_screencast
 */
#define GREENISLAND_SCREENCAST_FAILED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_screencast
 */
#define GREENISLAND_SCREENCAST_CANCELLED_SINCE_VERSION 1

/**
 * @ingroup iface_greenisland_screencast
 */
#define GREENISLAND_SCREENCAST_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_screencast
 */
#define GREENISLAND_SCREENCAST_RECORD_SINCE_VERSION 1

/**
 * @ingroup iface_greenisland_screencast
 * Sends an setup event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
greenisland_screencast_send_setup(struct wl_resource *resource_, int32_t width, int32_t height, int32_t stride, int32_t format)
{
	wl_resource_post_event(resource_, GREENISLAND_SCREENCAST_SETUP, width, height, stride, format);
}

/**
 * @ingroup iface_greenisland_screencast
 * Sends an frame event to the client owning the resource.
 * @param resource_ The client's resource
 * @param buffer client buffer that holds the data
 * @param time when the frame was recorded
 * @param transform optional transform applied to the image
 */
static inline void
greenisland_screencast_send_frame(struct wl_resource *resource_, struct wl_resource *buffer, uint32_t time, int32_t transform)
{
	wl_resource_post_event(resource_, GREENISLAND_SCREENCAST_FRAME, buffer, time, transform);
}

/**
 * @ingroup iface_greenisland_screencast
 * Sends an failed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param error error that has occurred
 * @param buffer frame buffer
 */
static inline void
greenisland_screencast_send_failed(struct wl_resource *resource_, int32_t error, struct wl_resource *buffer)
{
	wl_resource_post_event(resource_, GREENISLAND_SCREENCAST_FAILED, error, buffer);
}

/**
 * @ingroup iface_greenisland_screencast
 * Sends an cancelled event to the client owning the resource.
 * @param resource_ The client's resource
 * @param buffer old frame buffer
 */
static inline void
greenisland_screencast_send_cancelled(struct wl_resource *resource_, struct wl_resource *buffer)
{
	wl_resource_post_event(resource_, GREENISLAND_SCREENCAST_CANCELLED, buffer);
}

#ifdef  __cplusplus
}
#endif

#endif
