/* Generated by wayland-scanner 1.12.0 */

#ifndef GREENISLAND_SERVER_PROTOCOL_H
#define GREENISLAND_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_greenisland The greenisland protocol
 * @section page_ifaces_greenisland Interfaces
 * - @subpage page_iface_greenisland_applications - track running applications
 * - @subpage page_iface_greenisland_windows - track application windows
 * - @subpage page_iface_greenisland_window - interface to control application windows
 * @section page_copyright_greenisland Copyright
 * <pre>
 *
 * Copyright (C) 2015-2016 Pier Luigi Fiorini
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * </pre>
 */
struct greenisland_applications;
struct greenisland_window;
struct greenisland_windows;

/**
 * @page page_iface_greenisland_applications greenisland_applications
 * @section page_iface_greenisland_applications_desc Description
 *
 * This interface is used by UI modules interested in tracking running applications,
 * for example a library that expose the list of running applications to a launcher.
 * Only one client can bind this interface at a time.
 * @section page_iface_greenisland_applications_api API
 * See @ref iface_greenisland_applications.
 */
/**
 * @defgroup iface_greenisland_applications The greenisland_applications interface
 *
 * This interface is used by UI modules interested in tracking running applications,
 * for example a library that expose the list of running applications to a launcher.
 * Only one client can bind this interface at a time.
 */
extern const struct wl_interface greenisland_applications_interface;
/**
 * @page page_iface_greenisland_windows greenisland_windows
 * @section page_iface_greenisland_windows_desc Description
 *
 * This interface is used by UI modules interested in tracking application windows
 * for example a task bars and launchers.
 * Only one client can bind this interface at a time.
 * @section page_iface_greenisland_windows_api API
 * See @ref iface_greenisland_windows.
 */
/**
 * @defgroup iface_greenisland_windows The greenisland_windows interface
 *
 * This interface is used by UI modules interested in tracking application windows
 * for example a task bars and launchers.
 * Only one client can bind this interface at a time.
 */
extern const struct wl_interface greenisland_windows_interface;
/**
 * @page page_iface_greenisland_window greenisland_window
 * @section page_iface_greenisland_window_desc Description
 *
 * Manages and control an application window.
 * Only one client can bind this interface at a time.
 * @section page_iface_greenisland_window_api API
 * See @ref iface_greenisland_window.
 */
/**
 * @defgroup iface_greenisland_window The greenisland_window interface
 *
 * Manages and control an application window.
 * Only one client can bind this interface at a time.
 */
extern const struct wl_interface greenisland_window_interface;

/**
 * @ingroup iface_greenisland_applications
 * @struct greenisland_applications_interface
 */
struct greenisland_applications_interface {
	/**
	 * quit an application
	 *
	 * Ask the compositor to terminate a Wayland client with the
	 * specified application identifier.
	 * @param app_id application identifier
	 */
	void (*quit)(struct wl_client *client,
		     struct wl_resource *resource,
		     const char *app_id);
};

#define GREENISLAND_APPLICATIONS_REGISTERED 0
#define GREENISLAND_APPLICATIONS_UNREGISTERED 1
#define GREENISLAND_APPLICATIONS_FOCUSED 2
#define GREENISLAND_APPLICATIONS_UNFOCUSED 3

/**
 * @ingroup iface_greenisland_applications
 */
#define GREENISLAND_APPLICATIONS_REGISTERED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_applications
 */
#define GREENISLAND_APPLICATIONS_UNREGISTERED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_applications
 */
#define GREENISLAND_APPLICATIONS_FOCUSED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_applications
 */
#define GREENISLAND_APPLICATIONS_UNFOCUSED_SINCE_VERSION 1

/**
 * @ingroup iface_greenisland_applications
 */
#define GREENISLAND_APPLICATIONS_QUIT_SINCE_VERSION 1

/**
 * @ingroup iface_greenisland_applications
 * Sends an registered event to the client owning the resource.
 * @param resource_ The client's resource
 * @param app_id application identifier
 * @param pid process identifier
 */
static inline void
greenisland_applications_send_registered(struct wl_resource *resource_, const char *app_id, uint32_t pid)
{
	wl_resource_post_event(resource_, GREENISLAND_APPLICATIONS_REGISTERED, app_id, pid);
}

/**
 * @ingroup iface_greenisland_applications
 * Sends an unregistered event to the client owning the resource.
 * @param resource_ The client's resource
 * @param app_id application identifier
 * @param pid process identifier
 */
static inline void
greenisland_applications_send_unregistered(struct wl_resource *resource_, const char *app_id, uint32_t pid)
{
	wl_resource_post_event(resource_, GREENISLAND_APPLICATIONS_UNREGISTERED, app_id, pid);
}

/**
 * @ingroup iface_greenisland_applications
 * Sends an focused event to the client owning the resource.
 * @param resource_ The client's resource
 * @param app_id application identifier
 */
static inline void
greenisland_applications_send_focused(struct wl_resource *resource_, const char *app_id)
{
	wl_resource_post_event(resource_, GREENISLAND_APPLICATIONS_FOCUSED, app_id);
}

/**
 * @ingroup iface_greenisland_applications
 * Sends an unfocused event to the client owning the resource.
 * @param resource_ The client's resource
 * @param app_id application identifier
 */
static inline void
greenisland_applications_send_unfocused(struct wl_resource *resource_, const char *app_id)
{
	wl_resource_post_event(resource_, GREENISLAND_APPLICATIONS_UNFOCUSED, app_id);
}

#ifndef GREENISLAND_WINDOWS_TYPE_ENUM
#define GREENISLAND_WINDOWS_TYPE_ENUM
enum greenisland_windows_type {
	GREENISLAND_WINDOWS_TYPE_TOPLEVEL = 1,
	GREENISLAND_WINDOWS_TYPE_POPUP = 2,
	GREENISLAND_WINDOWS_TYPE_TRANSIENT = 3,
};
#endif /* GREENISLAND_WINDOWS_TYPE_ENUM */

#ifndef GREENISLAND_WINDOWS_STATE_ENUM
#define GREENISLAND_WINDOWS_STATE_ENUM
enum greenisland_windows_state {
	GREENISLAND_WINDOWS_STATE_INACTIVE = 0x0,
	GREENISLAND_WINDOWS_STATE_ACTIVE = 0x1,
	GREENISLAND_WINDOWS_STATE_MINIMIZED = 0x2,
	GREENISLAND_WINDOWS_STATE_MAXIMIZED = 0x3,
	GREENISLAND_WINDOWS_STATE_FULLSCREEN = 0x4,
	GREENISLAND_WINDOWS_STATE_KEEP_ABOVE = 0x5,
	GREENISLAND_WINDOWS_STATE_KEEP_BELOW = 0x6,
	GREENISLAND_WINDOWS_STATE_SHADED = 0x7,
	GREENISLAND_WINDOWS_STATE_ON_ALL_WORKSPACES = 0x8,
};
#endif /* GREENISLAND_WINDOWS_STATE_ENUM */

#define GREENISLAND_WINDOWS_WINDOW_MAPPED 0

/**
 * @ingroup iface_greenisland_windows
 */
#define GREENISLAND_WINDOWS_WINDOW_MAPPED_SINCE_VERSION 1


/**
 * @ingroup iface_greenisland_windows
 * Sends an window_mapped event to the client owning the resource.
 * @param resource_ The client's resource
 * @param type window type
 * @param state bitfield of state flags
 * @param title window title
 * @param app_id application identifier
 */
static inline void
greenisland_windows_send_window_mapped(struct wl_resource *resource_, struct wl_resource *id, uint32_t type, uint32_t state, const char *title, const char *app_id)
{
	wl_resource_post_event(resource_, GREENISLAND_WINDOWS_WINDOW_MAPPED, id, type, state, title, app_id);
}

#define GREENISLAND_WINDOW_TITLE_CHANGED 0
#define GREENISLAND_WINDOW_APP_ID_CHANGED 1
#define GREENISLAND_WINDOW_STATE_CHANGED 2
#define GREENISLAND_WINDOW_WORKSPACE_CHANGED 3
#define GREENISLAND_WINDOW_UNMAPPED 4

/**
 * @ingroup iface_greenisland_window
 */
#define GREENISLAND_WINDOW_TITLE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_window
 */
#define GREENISLAND_WINDOW_APP_ID_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_window
 */
#define GREENISLAND_WINDOW_STATE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_window
 */
#define GREENISLAND_WINDOW_WORKSPACE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_greenisland_window
 */
#define GREENISLAND_WINDOW_UNMAPPED_SINCE_VERSION 1


/**
 * @ingroup iface_greenisland_window
 * Sends an title_changed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param title window title
 */
static inline void
greenisland_window_send_title_changed(struct wl_resource *resource_, const char *title)
{
	wl_resource_post_event(resource_, GREENISLAND_WINDOW_TITLE_CHANGED, title);
}

/**
 * @ingroup iface_greenisland_window
 * Sends an app_id_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
greenisland_window_send_app_id_changed(struct wl_resource *resource_, const char *app_id)
{
	wl_resource_post_event(resource_, GREENISLAND_WINDOW_APP_ID_CHANGED, app_id);
}

/**
 * @ingroup iface_greenisland_window
 * Sends an state_changed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param flags bitfield of state flags
 */
static inline void
greenisland_window_send_state_changed(struct wl_resource *resource_, uint32_t flags)
{
	wl_resource_post_event(resource_, GREENISLAND_WINDOW_STATE_CHANGED, flags);
}

/**
 * @ingroup iface_greenisland_window
 * Sends an workspace_changed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param number workspace index
 */
static inline void
greenisland_window_send_workspace_changed(struct wl_resource *resource_, uint32_t number)
{
	wl_resource_post_event(resource_, GREENISLAND_WINDOW_WORKSPACE_CHANGED, number);
}

/**
 * @ingroup iface_greenisland_window
 * Sends an unmapped event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
greenisland_window_send_unmapped(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, GREENISLAND_WINDOW_UNMAPPED);
}

#ifdef  __cplusplus
}
#endif

#endif
