/* Generated by wayland-scanner 1.12.0 */

#ifndef GTK_SERVER_PROTOCOL_H
#define GTK_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_gtk The gtk protocol
 * @section page_ifaces_gtk Interfaces
 * - @subpage page_iface_gtk_shell - gtk specific extensions
 * - @subpage page_iface_gtk_surface - 
 */
struct gtk_shell;
struct gtk_surface;
struct wl_surface;

/**
 * @page page_iface_gtk_shell gtk_shell
 * @section page_iface_gtk_shell_desc Description
 *
 * gtk_shell is a protocol extension providing additional features for
 * clients implementing it. It is not backward compatible, and a client must
 * always only bind to the specific version it implements. If a client binds
 * to a version different from the version the server provides, an error will
 * be raised.
 * @section page_iface_gtk_shell_api API
 * See @ref iface_gtk_shell.
 */
/**
 * @defgroup iface_gtk_shell The gtk_shell interface
 *
 * gtk_shell is a protocol extension providing additional features for
 * clients implementing it. It is not backward compatible, and a client must
 * always only bind to the specific version it implements. If a client binds
 * to a version different from the version the server provides, an error will
 * be raised.
 */
extern const struct wl_interface gtk_shell_interface;
/**
 * @page page_iface_gtk_surface gtk_surface
 * @section page_iface_gtk_surface_api API
 * See @ref iface_gtk_surface.
 */
/**
 * @defgroup iface_gtk_surface The gtk_surface interface
 */
extern const struct wl_interface gtk_surface_interface;

#ifndef GTK_SHELL_CAPABILITY_ENUM
#define GTK_SHELL_CAPABILITY_ENUM
enum gtk_shell_capability {
	GTK_SHELL_CAPABILITY_GLOBAL_APP_MENU = 1,
	GTK_SHELL_CAPABILITY_GLOBAL_MENU_BAR = 2,
	GTK_SHELL_CAPABILITY_DESKTOP_ICONS = 3,
};
#endif /* GTK_SHELL_CAPABILITY_ENUM */

/**
 * @ingroup iface_gtk_shell
 * @struct gtk_shell_interface
 */
struct gtk_shell_interface {
	/**
	 */
	void (*get_gtk_surface)(struct wl_client *client,
				struct wl_resource *resource,
				uint32_t gtk_surface,
				struct wl_resource *surface);
};

#define GTK_SHELL_CAPABILITIES 0

/**
 * @ingroup iface_gtk_shell
 */
#define GTK_SHELL_CAPABILITIES_SINCE_VERSION 1

/**
 * @ingroup iface_gtk_shell
 */
#define GTK_SHELL_GET_GTK_SURFACE_SINCE_VERSION 1

/**
 * @ingroup iface_gtk_shell
 * Sends an capabilities event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
gtk_shell_send_capabilities(struct wl_resource *resource_, uint32_t capabilities)
{
	wl_resource_post_event(resource_, GTK_SHELL_CAPABILITIES, capabilities);
}

/**
 * @ingroup iface_gtk_surface
 * @struct gtk_surface_interface
 */
struct gtk_surface_interface {
	/**
	 */
	void (*set_dbus_properties)(struct wl_client *client,
				    struct wl_resource *resource,
				    const char *application_id,
				    const char *app_menu_path,
				    const char *menubar_path,
				    const char *window_object_path,
				    const char *application_object_path,
				    const char *unique_bus_name);
	/**
	 */
	void (*set_modal)(struct wl_client *client,
			  struct wl_resource *resource);
	/**
	 */
	void (*unset_modal)(struct wl_client *client,
			    struct wl_resource *resource);
};


/**
 * @ingroup iface_gtk_surface
 */
#define GTK_SURFACE_SET_DBUS_PROPERTIES_SINCE_VERSION 1
/**
 * @ingroup iface_gtk_surface
 */
#define GTK_SURFACE_SET_MODAL_SINCE_VERSION 1
/**
 * @ingroup iface_gtk_surface
 */
#define GTK_SURFACE_UNSET_MODAL_SINCE_VERSION 1

#ifdef  __cplusplus
}
#endif

#endif
